/* 	
	layer2.c 	part of TRIPP Traffic Rewriter for IP (v4) Packets
	by poplix@papuasia.org 2005

*/


#include "tripp.h"




//int build_layer2(struct ip_packet *pk, libnet_t *libnet_hnd,char *ifname, char *l2addr, u_int32_t ipaddr,u_int32_t netmask,u_int32_t gw){
int build_layer2(struct ip_packet *pk, libnet_t *libnet_hnd,struct intf *iface,u_int32_t gw){
    char *ethdst;
    libnet_ptag_t lneth=0;
    u_int32_t ipdst,netaddr;
    char bcast[]={ 0xff,0xff,0xff, 0xff,0xff,0xff };
    
    netaddr=(pk->ip->ip_src.s_addr & iface->netmask);
    
    if( (pk->ip->ip_dst.s_addr & iface->netmask) == netaddr || gw == 0 )
      ipdst=pk->ip->ip_dst.s_addr;
	else
	  ipdst=gw;
	
	if (ipdst == ( ~iface->netmask | netaddr ) ){ // ip broadcast
		ethdst=bcast;
	} else {
		ethdst=arpget(ipdst);
		  
		if(ethdst==NULL){
			ethdst=arp_resolve(ipdst,libnet_hnd,iface->name,iface->l2addr,iface->ipaddr);
			//arp_resolve delaya tutto...
			if(ethdst==NULL)return 0;
			
			arpadd(ipdst,ethdst);
		}
	}
	
	lneth=libnet_build_ethernet(ethdst, iface->l2addr, ETHERTYPE_IP, NULL,0,libnet_hnd,0);                                             
	if(lneth==-1)
			fprintf(stderr, "Eth forging error: %s\n", libnet_geterror(libnet_hnd));
	
	
	return 1;
	}
	
	
	
	/*
	
		char name[10];
	u_int mtu;
	u_int oldmtu;
	u_int type;
	
	u_int32_t ipaddr;
	u_int32_t netmask;
	
	u_char  l2addr[MAX_L2ADDR_SIZE];
	u_int	l2addr_size;
};
	
	*/